{
  Palette Maker Demo
  a TColorPalette manager
  explores various functions and other ways of using the TColorPalette
  first release: 150907
  perrault@sogetel.net
}


unit main;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf, LCLType, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ComCtrls, ExtCtrls, StdCtrls, Windows,
  Buttons, Spin, FileCtrl, FileUtil, ColorPalette;

type

  { TmainForm }

  TmainForm = class(TForm)
    aCopyAll: TAction;
    aInsertColor: TAction;
    aScreenPickCol: TAction;
    btnRefPalToggle: TButton;
    aRefreshPalet: TAction;
    aDelFile: TAction;
    aNewPal: TAction;
    ActionList1: TActionList;
    BLab: TLabel;
    BTBar: TTrackBar;
    btnConfig: TSpeedButton;
    btnSavePal: TButton;
    Button1: TButton;
    btnNewPal: TButton;
    CBRefPals: TComboBox;
    CbSelKind: TComboBox;
    cellColBox: TShape;
    chkSortedPal: TCheckBox;
    chkFlip: TCheckBox;
    chkCLNone: TCheckBox;
    chkAutoSave: TCheckBox;
    cListBox: TListBox;
    colorBox: TPanel;
    imgList1: TImageList;
    LbBtn2: TLabel;
    LbButton1: TLabel;
    lbCCnt: TLabel;
    lbCListCnt: TLabel;
    lbInfo2: TLabel;
    MemCurFile: TMemo;
    MenuItem2: TMenuItem;
    mExtendView: TMenuItem;
    mSaveMemo: TMenuItem;
    PanTPalet: TPanel;
    pCtrlSrc: TPageControl;
    popMemo: TPopupMenu;
    SBrdrColor: TShape;
    chkNoDups: TCheckBox;
    SESize: TSpinEdit;
    SEDist: TSpinEdit;
    SEClmns: TSpinEdit;
    sBtnSaveRefPalet: TSpeedButton;
    sBtnScrPick: TSpeedButton;
    sBtnComSort: TSpeedButton;
    tabColList: TTabSheet;
    TabSrce: TTabSheet;
    edPalName: TEdit;
    FListBox: TFileListBox;
    imgList: TImageList;
    Label1: TLabel;
    lbFileTab2: TLabel;
    lbInfo0: TLabel;
    lbInfo1: TLabel;
    lbLoadPal: TLabel;
    lbFileTab: TLabel;
    lbFileTab1: TLabel;
    LbBtn1: TLabel;
    LblColCount: TLabel;
    LblSelKind: TLabel;
    LbButton: TLabel;
    lbTopName: TLabel;
    lbTopRGB: TLabel;
    MenuItem1: TMenuItem;
    panBottom: TPanel;
    panTopPal: TPanel;
    refPalet: TColorPalette;
    colPalet: TColorPalette;
    configOkBtn: TButton;
    configPanel: TPanel;
    cTitleLab: TLabel;
    GLab: TLabel;
    GTBar: TTrackBar;
    HexLab: TLabel;
    mSetBG: TMenuItem;
    palPan: TPanel;
    pgCntrl: TPageControl;
    RLab: TLabel;
    RTBar: TTrackBar;
    sBtnDelFile: TSpeedButton;
    sSample: TShape;
    SSelColor: TShape;
    TabMix: TTabSheet;
    TabConfig: TTabSheet;
    aRememberLast: TAction;
    PopMen: TPopupMenu;
    mCopyToClip: TMenuItem;
    pmGetColor: TMenuItem;
    TabPals: TTabSheet;
    TabFiles: TTabSheet;
    TBar: TToolBar;
    TBarAddColor: TToolBar;
    TBarPanel: TPanel;
    aRemoveColor: TAction;
    aUpdateColor: TAction;
    popList: TPopupMenu;
    RemoveColor1: TMenuItem;
    aUpdateColor1: TMenuItem;
    PopPalet: TPopupMenu;
    aAddColor: TAction;
    aRemColPal: TAction;
    aLoadColPal: TAction;
    aRemColPal1: TMenuItem;
    aClearPalette: TAction;
    aSaveFile: TAction;
    palRename: TMenuItem;
    PopColBox: TPopupMenu;
    TBtnDel: TToolButton;
    TBBtnPrev: TToolButton;
    TBBtnNext: TToolButton;
    TBAddColor: TToolButton;
    TBInsertColor: TToolButton;
    TBUpdateColor: TToolButton;
    updateTimer: TTimer;
    toolPalet: TColorPalette;
    UpdateColor1: TMenuItem;
    pCopyHex: TMenuItem;
    focusImg: TImage;
    popMain: TPopupMenu;
    mAutoLoad: TMenuItem;
    webCol: TLabel;
    procedure aCopyAllExecute(Sender: TObject);
    procedure aDelFileExecute(Sender: TObject);
    procedure aInsertColorExecute(Sender: TObject);
    procedure aNewPalExecute(Sender: TObject);
    procedure aRefreshPaletExecute(Sender: TObject);
    procedure aScreenPickColExecute(Sender: TObject);
    procedure btnRefPalToggleClick(Sender: TObject);
    procedure btnSavePalClick(Sender: TObject);
    procedure CBRefPalsSelect(Sender: TObject);
    procedure CbSelKindSelect(Sender: TObject);
    procedure chkCLNoneMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure chkFlipChange(Sender: TObject);
    procedure chkSortedPalChange(Sender: TObject);
    procedure mExtendViewClick(Sender: TObject);
    procedure mSaveMemoClick(Sender: TObject);
    procedure PanTPaletMouseLeave(Sender: TObject);
    procedure pgCntrlChange(Sender: TObject);
    procedure sBtnComSortClick(Sender: TObject);
    procedure sBtnSaveRefPaletClick(Sender: TObject);
    procedure chkNoDupsChange(Sender: TObject);
    procedure sBtnScrPickMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sBtnScrPickMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SEClmnsChange(Sender: TObject);
    procedure SEDistChange(Sender: TObject);
    procedure SESizeChange(Sender: TObject);
    procedure TBBtnNextClick(Sender: TObject);
    procedure colPaletColorPick(Sender: TObject; AColor: TColor;
      Shift: TShiftState);
    procedure colPaletMouseEnter(Sender: TObject);
    procedure colPaletMouseLeave(Sender: TObject);
    procedure colPaletMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure configOkBtnClick(Sender: TObject);
    procedure FListBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mSetBGClick(Sender: TObject);
    procedure RTBarChange(Sender: TObject);
    procedure BTBarChange(Sender: TObject);
    procedure GTBarChange(Sender: TObject);
    procedure mCopyToClipClick(Sender: TObject);
    procedure cListBoxClick(Sender: TObject);
    procedure HexLabClick(Sender: TObject);
    procedure SSelColorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TBtnDelClick(Sender: TObject);
    procedure TBBtnPrevClick(Sender: TObject);
    procedure toolPaletMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure updateTimerStartTimer(Sender: TObject);
    procedure updateTimerStopTimer(Sender: TObject);
    procedure updateTimerTimer(Sender: TObject);
    procedure webColMouseEnter(Sender: TObject);

    procedure aRemoveColorExecute(Sender: TObject);
    procedure aUpdateColorExecute(Sender: TObject);
    procedure aAddColorExecute(Sender: TObject);
    procedure aLoadColPalExecute(Sender: TObject);
    procedure aRemColPalExecute(Sender: TObject);
    procedure aClearPaletteExecute(Sender: TObject);
    procedure aSaveFileExecute(Sender: TObject);
    procedure edPalNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure palRenameClick(Sender: TObject);
    procedure pCopyHexClick(Sender: TObject);
    procedure colorBoxClick(Sender: TObject);
    procedure cellColBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
    cIndex: integer;
    curColor: string;
    curLab: TLabel;
    unSorted: string;
    compareCol, colPicked : boolean;
    TrkArr : array[0..2] of TTrackBar;
    ScreenDC: HDC;
    timeGone: integer;
    procedure prepTrackBars;
    procedure setHexValue;
    procedure clearPalet;
    procedure setColorPalet;
    procedure updateListBox;
    procedure doMoveColor(fromInd, toInd: integer);
    function getColStr(ind:integer):string;
    procedure setDuplicates;
    procedure doSavePalFile;
    procedure doLoadPalFile(fName: string);
    procedure setInfoMsg(msg: string);


  public

    colStr: string;
    colStrList: string;
    palName, curFileName: string;
    palColors,
    palProps: tStringList;
    curShape: TShape;
    procedure setTrackBars(str: string);
    procedure setRGBTrackBars(AColor: TColor);
  end;

const
  cMark: string='$00';
  builtPalStr: string = 'Standard,Extended,System,Std+system,Ext+system,Gradient,HTML,Websafe';

resourceString
  nProgName   = 'PalMaker' ;
  nCreator    = 'Pero ' ;
  nProgDesc   = 'TColorPalette demos ';
  nVersion    = 'version 0.1 ' ;
  nRevision   = ' --.--.--'  ;

var
  mainForm: TmainForm;

  mainPath, filePath, initName: string;
  initDone: boolean;

  RVal, GVal, BVal: integer;


implementation

{$R *.lfm}


uses fileUnit, Clipbrd;



procedure TmainForm.FormCreate(Sender: TObject);
begin
  initDone := false;
  mainPath := extractFilePath(application.exeName);
  initName := mainPath + nProgName + '.ini';
  filePath := mainPath + 'pals';
  if not directoryExists(filePath) then
    createDir(filePath);
  FListBox.directory := filePath;
  filePath :=  filePath + '\';
  FListBox.mask := '*';

  CBRefPals.Items.commaText := builtPalStr ;
  CBRefPals.ItemIndex := 0;
  width := 475;  height:= 375;
  //width := 725;  //height:= 500;
  cListBox.visible := true;

  palColors := tStringList.create;
  palProps := TStringList.create;

  prepTrackBars;
  //ColPalet.PaletteKind := TPaletteKind(0);

  
end;




procedure TmainForm.FormShow(Sender: TObject);
begin
 readInit(initName);
 caption := nProgName + ' ' +  nVersion;

 if mAutoLoad.Checked and fileExists(curFileName) then
 begin
    palName := extractFileName(curFileName);
    EdPalName.Text := palName ;
    doLoadPalFile(curFileName);
   end;

 pgCntrlChange(self);
 initDone := true;
end;



procedure TmainForm.FormDestroy(Sender: TObject);
begin
  colStrList := cListBox.Items.CommaText;
  if chkAutoSave.checked then doSavePalFile;
  palColors.free;
  palProps.free;
  writeInit(initName);
end;


procedure TmainForm.prepTrackBars;
var i: word;
begin
  trkArr[0]:= RTBar;
  trkArr[1]:= GTBar;
  trkArr[2]:= BTBar;
  for i := 0 to high(trkArr) do
    begin
       trkArr[i].height := 20;
       trkArr[i].tickStyle := tsNone;
    end;
end;





procedure TmainForm.RTBarChange(Sender: TObject);
begin
RLab.Tag := RTBar.position;
RLab.Caption := intToStr(RTBar.position);
setHexValue;
end;


procedure TmainForm.GTBarChange(Sender: TObject);
begin
GLab.Tag := GTBar.position;
GLab.Caption := intToStr(GTBar.position);
setHexValue;
end;



procedure TmainForm.BTBarChange(Sender: TObject);
begin
BLab.Tag := BTBar.position;
BLab.Caption := intToStr(BTBar.position);
setHexValue;
end;




procedure TmainForm.setHexValue;
var rgbStr, bgrStr : string;
begin
  bgrStr := IntToHex(BLab.tag,2)
          + IntToHex(GLab.tag,2)
          + IntToHex(RLab.tag,2);

  rgbStr := IntToHex(RLab.tag,2)
          + IntToHex(GLab.tag,2)
          + IntToHex(BLab.tag,2);


  colStr :=  cMark + bgrStr;
  curColor := colStr;
  HexLab.caption :=  colStr ;
  //colorBox.Brush.color := stringToColor(colStr) ;
  colorBox.color := stringToColor(colStr) ;
  if not compareCol then cellColBox.Brush.Color := colorBox.Color;
  webCol.caption := '#' + lowerCase(rgbStr);

  if TBUpdateColor.down then colPalet.colors[cIndex] := colorBox.color ;
end;


procedure TmainForm.setTrackBars(str: string);
begin
  setRGBTrackBars( stringToColor(str));
end;

procedure TmainForm.setRGBTrackBars(AColor: TColor);
begin
  rVal := red(aColor);
  RTBar.position := rVal;
  gVal := green(aColor);
  GTBar.position := gVal;
  bVal := blue(aColor);
  BTBar.position := bVal;
end;


////////////////////////////////////////
//  MIXER TAB

procedure TmainForm.chkSortedPalChange(Sender: TObject);
begin
   TBBtnPrev.enabled := not chkSortedPal.checked;
   TBBtnNext.enabled := not chkSortedPal.checked;
   TBInsertColor.enabled := not chkSortedPal.checked;
   TBUpdateColor.enabled := not chkSortedPal.checked;
   cListBox.Sorted := chkSortedPal.checked;
   sBtnComSort.enabled := chkSortedPal.checked;

   with chkSortedPal do
    if not checked then
     begin
       cListBox.items.commaText := unsorted;
     end;

   setColorPalet;
end;

procedure TmainForm.sBtnComSortClick(Sender: TObject);
begin
    cListBox.Sorted := false;
    updateListBox;
    unsorted := cListBox.items.commaText;
    chkSortedPal.checked := false;
end;

procedure TmainForm.chkNoDupsChange(Sender: TObject);
begin
  setDuplicates;
end;




procedure TmainForm.setDuplicates;
var outText, tmp: string;
    i: integer;
begin
   if not chkSortedPal.checked then unSorted := cListBox.items.commaText;
   cListBox.Sorted := chkSortedPal.checked;

   if chkNoDups.checked then
   with cListBox do
     begin
        for i := 0 to count-1 do
        begin
          tmp := items[i];
          if pos(tmp, outText) = 0 then
             if outText = '' then outText := tmp
             else
                outText := outText + ',' + tmp;
        end;
      Items.commaText := outText;
   end;
    setColorPalet;
    updateListBox;
end;


/////////////////////////////////////




///////////////////////////////////////////////////////////
// Palet Tab

procedure TmainForm.CBRefPalsSelect(Sender: TObject);
var i: word;
begin
  with CBRefPals do
  begin
    if btnRefPalToggle.caption = 'Built-in' then
        refPalet.loadPalette( filePath + items[itemIndex] )
        else
        begin
          refPalet.PaletteKind := TPaletteKind(ItemIndex);
          if itemIndex = items.count-1 then   // webSafePalet ... too long with 6 cols
              refpalet.columnCount := 12;     // override default by issuing new count after drawing
        end;
  end;
  refPalet.refresh;
end;


procedure TmainForm.btnRefPalToggleClick(Sender: TObject);
begin
  with btnRefPalToggle do
  begin
    if caption = 'Directory' then
    begin
      caption := 'Built-in';
      cbRefPals.items.commaText := fListBox.items.commaText;
    end else
    begin
      caption := 'Directory';
      cbRefPals.items.commaText := builtPalStr;
    end;
   end;
  CBRefPals.itemIndex := 0;
  CBrefPalsSelect(self);
end;




procedure TmainForm.sBtnSaveRefPaletClick(Sender: TObject);
begin
  refPalet.SavePalette(filePath+CBRefPals.Text);
end;





procedure TmainForm.btnSavePalClick(Sender: TObject);
begin
  PalName := edPalName.text ;
  if PalName <> '' then
    doSavePalFile;
end;

procedure TmainForm.aCopyAllExecute(Sender: TObject);
var i: word;
begin
  cListBox.clear;
  with refPalet do
     for i := 0 to colorCount-1 do
       cListBox.items.Add( Format('$00%0.2x%0.2x%0.2x',
                     [Red(colors[i]), Green(colors[i]), Blue(colors[i])]) );
  setColorPalet
end;

procedure TmainForm.aDelFileExecute(Sender: TObject);
begin
  //deleteFile(fListBox.FileName);
  deleteFile(pChar(fListBox.FileName));
  fListBox.UpdateFileList;
end;



procedure TmainForm.aNewPalExecute(Sender: TObject);
begin
  PalName := '';
  edPalName.text := 'New' ;
  clearPalet;
  setInfoMsg('New Palette created from the Config Tab properties');
end;



////////////////////////////////////////////////////
//  TBar Btns

procedure TmainForm.TBtnDelClick(Sender: TObject);
begin
  colPalet.DeleteColor(cIndex);
  updateListBox;
end;


procedure TmainForm.doMoveColor(fromInd, toInd: integer);
begin
  with cListBox do
     Items.Move(fromInd, toInd);
  setColorPalet;
  cIndex := toInd;
  cListBox.itemIndex := cIndex;
  unSorted := cListBox.Items.commaText;
  cListBoxClick(self);
end;

procedure TmainForm.TBBtnPrevClick(Sender: TObject);
var newIndex: integer;
begin
  newIndex := cIndex-1;
  if newIndex < 0 then newIndex := cListBox.count -1;
  doMoveColor(cIndex, newIndex);
end;

procedure TmainForm.TBBtnNextClick(Sender: TObject);
var newIndex: integer;
begin
  newIndex := cIndex+1;
  if newIndex > cListBox.count -1  then newIndex := 0;
  doMoveColor(cIndex, newIndex);
end;


//////////////////////////////////////////////////////
// colPalet
procedure TmainForm.colPaletColorPick(Sender: TObject; AColor: TColor;
  Shift: TShiftState);
begin
  cIndex := colPalet.PickedIndex;
  cellColBox.brush.Color := AColor ;
  setRGBTrackBars(AColor);
end;

procedure TmainForm.colPaletMouseEnter(Sender: TObject);
begin
  panTopPal.visible := true;
  colPicked := false;
end;

procedure TmainForm.colPaletMouseLeave(Sender: TObject);
begin
  if not colPicked then
     panTopPal.visible := false;
end;

procedure TmainForm.colPaletMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if not ColPicked then
  with sSample.Brush do
  begin
      Color := Colpalet.MouseColor;
      caption := colorToString(color);
      lbTopName.caption := Format('#%0.2x%0.2x%0.2x',[Blue(color), Green(color), Red(color)]);
      lbTopRGB.caption := Format('rgb(%d,%d,%d)',[Red(color), Green(color), Blue(color)]);
   end;
end;



////////////////////////////////////////////////////
//  TabConfig

procedure TmainForm.toolPaletMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  curShape.brush.color := toolPalet.Colors[toolPalet.mouseIndex]; // toolPalet.mouseColor; //
  panTPaletMouseLeave(self);
end;




procedure TmainForm.chkCLNoneMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  curShape.brush.color := clNone;
  panTPaletMouseLeave(self);
end;


procedure TmainForm.PanTPaletMouseLeave(Sender: TObject);
begin
  panTPalet.visible := false;
end;

procedure TmainForm.pgCntrlChange(Sender: TObject);
var sMsg: string;
begin
  with pgCntrl do
  begin
    case pageIndex of
      0: sMsg := 'Current working palette (right panel) and load and save options (left).';
      1: begin
           sMsg := 'Color Mixer and operations on the working palette.';
           TBarAddColor.parent :=  tabMix;
           TBUpdateColor.Style := tbsCheck;


        end;
      2: begin
          sMsg := 'Ref. Palette (built-in or saved) to copy colors from)';
          TBarAddColor.parent :=  tabPals;
          TBUpdateColor.Style := tbsButton;
         end;
      3: sMsg := 'Configuration and options for the working palette';
    end;
    sBtnSaveRefPalet.visible := pageIndex = 2 ;
    setInfoMsg(sMsg);
  end;
end;








procedure TmainForm.SSelColorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //curShape := SSelColor;
  curShape := sender as TShape;
  with panTPalet do
  begin
    parent := configPanel;
    left := curShape.left-(panTPalet.width div 2);
    top := curShape.top-20;
    visible := true;
  end;
  with colpalet do
  begin
     SelectionColor:= sSelColor.brush.color;
     ButtonBorderColor := sBrdrColor.brush.color;
     refresh;
  end;
end;



procedure TmainForm.SESizeChange(Sender: TObject);
begin
  colPalet.ButtonWidth := SESize.value ;
  colPalet.ButtonHeight := SESize.value ;
end;



procedure TmainForm.SEDistChange(Sender: TObject);
begin
  colPalet.ButtonDistance := SEDist.value ;
end;


procedure TmainForm.SEClmnsChange(Sender: TObject);
begin
  colPalet.ColumnCount := SEClmns.value ;
end;



procedure TmainForm.CbSelKindSelect(Sender: TObject);
begin
  // ColPalet.SelectionKind :=
  if initDone then
  begin
    ColPalet.SelectionKind := TPaletteSelectionKind(CbSelKind.ItemIndex);
    colPalet.Refresh;
  end;
end;


procedure TmainForm.chkFlipChange(Sender: TObject);
begin
  with colPalet do
  begin
     Flipped := chkFlip.checked;
     if flipped then
       begin
         TBBtnPrev.ImageIndex := 7;
         TBBtnNext.imageIndex := 8;
       end else begin
          TBBtnPrev.ImageIndex := 5;
          TBBtnNext.imageIndex := 6;
       end;
   end;
end;


procedure TmainForm.mExtendViewClick(Sender: TObject);
begin
  if mExtendView.checked then width := 725
    else width := 500;
end;




procedure TmainForm.configOkBtnClick(Sender: TObject);
var sKind: TPaletteSelectionKind;
begin

  with colPalet do
  begin
     SavePalette(curFileName);
     loadPalette(curFileName); // updates file
     //refresh;
  end;
end;


/////////////////////////////////////////////////////////////////////


procedure TmainForm.mCopyToClipClick(Sender: TObject);
begin
   clipBoard.AsText := curLab.caption; // hexLab.caption ;
end;





procedure TmainForm.cListBoxClick(Sender: TObject);
begin
 if cListBox.Count > 0 then
 begin
  cIndex := cListBox.ItemIndex;
  curColor := cListBox.items[cIndex];
  colPalet.PickedIndex := cIndex;
  setTrackBars(curColor);
 end;
end;


procedure TmainForm.aRemoveColorExecute(Sender: TObject);
begin
 with cListBox do
 begin
  if (Count > 0) and (itemIndex > -1) then
       begin
        cIndex := cListBox.ItemIndex;
        cListBox.Items.Delete(cIndex);
       end;
 end;

 setColorPalet;
end;




procedure TmainForm.aClearPaletteExecute(Sender: TObject);
begin
   clearPalet;
end;


procedure TmainForm.clearPalet;
begin
   with colPalet do
   begin
     ClearColors;
     //columnCount:= 0;   // columnCount will have to be reset to addColors...
     columnCount := SEClmns.Value;
     colorBoxClick(self);
     addColor(stringToColor(colStr));
     refresh;
     lbCCnt.caption := intToStr(colorCount);
   end;
   updateListBox;
end;


procedure TmainForm.setColorPalet;
var i: word;
begin
   cListBox.refresh;
   clearPalet;
   with colPalet do
   begin
      columnCount := SEClmns.value;
      for i := 0 to cListBox.Count-1 do
        addColor(stringToColor(cListBox.items[i]),'');
      refresh;
      lbCCnt.caption := intToStr(colorCount);
   end;
end;

procedure TmainForm.updateListBox;
var i: word;
begin
 with cListBox do
 begin
  clear;
  with colPalet do
  for i := 0 to colorCount-1 do
    items.add(colortoString(colors[i]));
  lbCListCnt.caption := intToStr(Count);
 end;
end;


procedure TmainForm.aRefreshPaletExecute(Sender: TObject);
begin
  setColorPalet;
end; {aRefreshPaletExecute}



/// screen color picker  // TODO: could/should be adapted to other OS
procedure TmainForm.aScreenPickColExecute(Sender: TObject);
begin
  ScreenDC := GetDC(0);
  if (ScreenDC <> 0) then
    UpdateTimer.Enabled := True;
end;


procedure TmainForm.sBtnScrPickMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   aScreenPickColExecute(self)
end;

procedure TmainForm.sBtnScrPickMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdateTimer.Enabled := false;
end;

procedure TmainForm.updateTimerStartTimer(Sender: TObject);
begin
   timeGone := 0;
end;

procedure TmainForm.updateTimerStopTimer(Sender: TObject);
begin
   ReleaseDC(GetDesktopWindow, ScreenDC);
   //caption := 'Timer Stopped';
end;

procedure TmainForm.updateTimerTimer(Sender: TObject);
var
  CursorPos: TPoint;
begin
  inc(timeGone);
  if timeGone > 100 then updateTimer.enabled := false //could ask if more time is needed...
    else
      if GetCursorPos(CursorPos) then
      begin
        Caption := 'Cursor pos: [' + IntToStr(CursorPos.x) + '; ' + IntToStr(CursorPos.y) + ']'
                + ' ' + intToStr(timeGone);
        ColorBox.Color := GetPixel(ScreenDC, CursorPos.x, CursorPos.y);
      end;
end;



//////////////////////

procedure TmainForm.mSetBGClick(Sender: TObject);
begin
  palPan.Color := colPalet.colors[cIndex];
  //palPan.Color := stringToColor(curColor);
end;


procedure TmainForm.HexLabClick(Sender: TObject);
begin
  curLab := sender as TLabel;
  curColor := (hexLab.Caption);
  setTrackBars(curColor);
end;


procedure TmainForm.webColMouseEnter(Sender: TObject);
begin
   curLab := sender as TLabel;
end;

procedure TmainForm.pCopyHexClick(Sender: TObject);
begin
   clipBoard.AsText := hexLab.caption ;
end;



///////////////////////////////////////////////////////////////////////////

function TmainForm.getColStr(ind:integer):string;
var maxStr: integer;
    res, tmp: string;
begin
  maxStr := cListBox.Count ;
  res := '$FFFFFFFF';
  if  (maxStr > 0) and (ind < maxStr) then
       res := cListBox.Items[ind];
  result := res;
end;



procedure TmainForm.colorBoxClick(Sender: TObject);
begin
  compareCol := not CompareCol;
  if not compareCol then
     cellColBox.Brush.Color := colorBox.Color
  else
     cellColBox.Brush.Color := colPalet.PickedColor; // stringToColor(cListBox.items[cIndex]);

end;


procedure TmainForm.cellColBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  colorBoxClick(self);
end;



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
// PalList

procedure TmainForm.aAddColorExecute(Sender: TObject);
begin
 case pgCntrl.pageIndex of
   1: colPalet.addColor(stringToColor(colStr));
   2: colPalet.AddColor(refPalet.PickedColor) ;
 end;
 colPalet.refresh;
 updateListBox;
 if chkNoDups.checked then setDuplicates;
end;



procedure TmainForm.aInsertColorExecute(Sender: TObject);
begin
 if colPalet.ColorCount = 0 then begin
     aAddColorExecute(self);
     exit;
  end;

  if cIndex = -1 then cIndex := 0;
  case pgCntrl.pageIndex of
    1: colPalet.insertColor(cIndex,stringToColor(colStr));
    2: colPalet.InsertColor(cIndex,refPalet.PickedColor) ;
  end;

  colPalet.refresh;
  updateListBox;
  if chkNoDups.checked then setDuplicates;
end;


procedure TmainForm.aUpdateColorExecute(Sender: TObject);
begin
 if colPalet.colorCount=0 then exit;
 if cIndex = -1 then cIndex := 0;

  case pgCntrl.pageIndex of
    1: colPalet.colors[cIndex] := colorbox.color;
    2: colPalet.colors[cIndex]:= refPalet.PickedColor ;
  end;

  updateListBox;
  if chkNoDups.checked then setDuplicates;
end;


procedure TmainForm.edPalNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   {
   if key = VK_RETURN then
     begin

     end;
     }
end;

procedure TmainForm.palRenameClick(Sender: TObject);
begin
  edPalName.visible := true;
end;



procedure TmainForm.aLoadColPalExecute(Sender: TObject);
var tmp: string;
begin
 //save any change made to list
 if initDone then  //and autoSaveChk.checked...
    aSaveFileExecute(self);
 // get list from palList;
 doLoadPalFile(curFileName); // load new...
end;


procedure TmainForm.aRemColPalExecute(Sender: TObject);
begin
  cListBox.Clear;
  clearPalet;
end;



procedure TmainForm.aSaveFileExecute(Sender: TObject);
begin
  doSavePalFile;
end;



procedure TmainForm.FListBoxClick(Sender: TObject);
begin
  edPalName.text := extractFileName(fListBox.fileName);
  doLoadPalFile(fListBox.FileName);
end;



procedure TmainForm.doSavePalFile;
begin
   stringReplace(curFileName,'\\','\',[]);   //fileListBox adds a '\'...
   if curFileName <> '' then
      colPalet.SavePalette(curFileName);
   setInfoMsg('Saved: ' + curFileName);
end;


procedure TmainForm.doLoadPalFile(fName: string);
var i: word;
begin
  if not fileExists(fName) then exit;

  initDone := false;
  with ColPalet do
  begin
    loadPalette(fName, piAll);
    //refresh;
    SEDist.value  := ButtonDistance;
    SESize.Value  := buttonWidth;
    CbSelKind.ItemIndex := ord(SelectionKind);
    SSelColor.brush.color := SelectionColor;
    sBrdrColor.Brush.color := buttonBorderColor;
    SEClmns.Value := columnCount ;
    chkFlip.Checked := flipped ;
    lbCCnt.caption := intToStr(colorCount);

    updateListBox;
    unSorted := cListBox.items.commaText;

    MemCurFile.Lines.loadFromFile(fName);
    curFileName := fName;  // in case not assigned yet...
    setInfoMsg('Current palette: ' + palName);
  end;
  initDone := true;
end;


//////////////////////////////////////////////////////////////////////////////

procedure TmainForm.setInfoMsg(msg: string);
begin
  lbInfo0.width := 490;
  lbInfo1.caption := '';
  lbInfo0.caption := msg;
end;


/////////////////////////////////////////////////////////////////////////
// second PCtrl  -- testing

procedure TmainForm.mSaveMemoClick(Sender: TObject);
begin
  memCurFile.Lines.saveToFile(curFileName) ;
end;





end.
